	list	P=PIC12F629		
 
	#include	<P12F629.INC>
 __config _PWRTE_ON  &_MCLRE_OFF &_WDT_OFF &_INTRC_OSC_NOCLKOUT &_CP_ON &_CPD_OFF &_BODEN_OFF
;   ID
 __IDLOCS		H'0306'
;  EEPROM
			ORG 	0X00002100
			DT		" http://sprinter4wd.narod.ru/ "

;------------- define hardware --------------

#define	 LATCH	GPIO,1		; -out
#define	 CLK	GPIO,0		; -out
#define	 B_inp	GPIO,2
;#define	 RX	GPIO,3		; -in

;4 	-GP5- ()   0-On
POWER		EQU		5
;
;2 	-GP4- ()   
TEMPER		EQU		4

	CONSTANT  C_Trisio	= b'00011000' ;   TRISIO
	CONSTANT  C_Wpu 	= b'00000000' ;   WPU
	CONSTANT  C_GPIO_INIT=b'00100000' ;   GPIO
	CONSTANT  C_IOCB 	= b'00000000' ;   IOCB
	CONSTANT  C_ForSleep= .15		; -     


;------------- define constants -------------

	CONSTANT  LCDCLR = b'00000001' ; clears display, resets cursor
	CONSTANT  LCDCH  = b'00000010' ; cursor home
	CONSTANT  LCDCR  = b'00000110' ; cursor move to right
	CONSTANT  LCDCL  = b'00000100' ; cursor move to left
	CONSTANT  LCDSL  = b'00011000' ; shifts display to left
	CONSTANT  LCDSR  = b'00011100' ; shifts display to right
	CONSTANT  LCDL1  = b'10000000' ; selects line 1
	CONSTANT  LCDL2  = b'11000000' ; selects line 2

;------------- define variables -------------

	CBLOCK	0x20		; beginning of RAM (PIC12F629)
; Delay
	cpt1
	cpt2
	cpt3
; others
	ac164		; variable to be serialized into the 74AC164
	store		;        74hc595
	cmd_car		; Bit0: =RS: =0, means cmd to LCD ; =1, means char to LCD
				; Bit1: =E
	byte_num	; =0, means receiving a command to LCD
	buffer		; receive one byte from serial link
;	bauds_1		; 1 bit RS232 coeff. delay 
;	bauds_2		; 1/2 bit RS232 coeff. delay
	ndxChar		; index of char. to pick from a table to display

	bin0		; 8-   (0-255 -   []),      -
	bcd0 		;      - 
	bcd1   		;      - 
	bcdF		;     -  (   )
	count		;    
	count2		; 2   
	temp		;    
	
	COUNTER		;  
	TH			;  -  
	TL			;  -  
	TF			;  -  
	CRCPIC		;  ,  
	TRY			;    1-Wire
	TEMP1       ;   
	TEMP2  		;  
	Reg_1		;   
	Reg_2		; 
	Reg_3		;  ()
	ForSleep	;    

	ENDC

;--------------------------------------------------------------------
; macro to put a literal value (constant) into a register
;--------------------------------------------------------------------
MOVLF	macro	literal, file	; literal -> file
	MOVLW	literal
	MOVWF	file
	endm
;                         ---  ---

jnz	MACRO	metka1             ;  ,
	btfss	STATUS,Z           ;   0
	goto	metka1
	endm
jz	MACRO	metka2             ;  ,
	btfsc	STATUS,Z           ;  0
	goto	metka2
	endm
mvi     MACRO   DEST2,CONST2    	   ;    
	movlw   CONST2	
	movwf   DEST2
	endm

;--------------------------------------------------------------------
; macro to display a text, up to 16 char. 
;--------------------------------------------------------------------
LCDTXT	macro	line, text	; line = LCDL1 or LCDL2 (select line 1 or 2)
	LOCAL	nextchar
	LOCAL	exit

	MOVLW	line
	CALL	cmd_aff		; select a line

	CLRF	ndxChar
nextchar
	MOVF 	ndxChar,w	; index of char. to be ...
	CALL 	text		; ... picked from table text
	ANDLW	0FFh		; ASCII zero ?
	BZ	exit		; branch on Zero <=> BTFSC STATUS,Z   GOTO exit
	CALL	car_aff
	INCF	ndxChar,f
	GOTO	nextchar
exit
	endm

;---------------------------------------------------------------------
	ORG	0x00		; Reset vector
	GOTO	Main
;---------------------------------------------------------------------

msgLin1	ADDWF PCL,f
	DT	"  Temperature"
	DT	0

msgLin2	ADDWF PCL,f
	DT	"BEST REGARDS!!!"
	DT	0

msgLin3	ADDWF PCL,f
	DT	"    OSHIBKA  "
	DT	0

BCD_FRACT	ADDWF	PCL,f
			retlw	.0			; 0
			retlw	.1			; 1
			retlw	.1			; 2
			retlw	.2			; 3
			retlw	.3			; 4
			retlw	.3			; 5
			retlw	.4			; 6
			retlw	.4			; 7
			retlw	.5			; 8
			retlw	.6			; 9
			retlw	.6			; 10
			retlw	.7			; 11
			retlw	.8			; 12
			retlw	.8			; 13
			retlw	.9			; 14
			retlw	.9			; 15
;---------------------- Delay 1002 us (approx. 1 ms) ------------------
Delay1ms			; 2 us for CALL
	MOVLF	0F9h,cpt1	; 2 us
etiq2	NOP			; loop = 4 us * (F9h=249d) = 996 us
	DECFSZ	cpt1, f	 
	GOTO	etiq2
	RETLW	00h		; 2 us for RETURN

;----------------------- Delay 15 ms ---------------------------------
Delay15ms
	MOVLF	0Fh, cpt2	; cpt2 = 15d
etiq3	CALL	Delay1ms 	; 1 ms, called 15 times
	DECFSZ	cpt2, f	
	GOTO	etiq3	
	RETLW	00h

;------------------- INIT LCD ----------------------------------------
init_aff
	BCF		cmd_car,0		; by default, prepare a command for LCD

	movlw	b'00110000'
	movwf	store		;  
	call	nibble		;   
	CALL    Delay1ms
	CALL    Delay1ms
	CALL    Delay1ms
	CALL    Delay1ms

	movlw	b'00110000'
	movwf	store		;  
	call	nibble		;   
	CALL    Delay1ms
	CALL    Delay1ms
	CALL    Delay1ms
	CALL    Delay1ms
	CALL    Delay1ms
	CALL    Delay1ms
	CALL    Delay1ms
	CALL    Delay1ms

	movlw	b'00110000'
	movwf	store		;  
	call	nibble		;   
	CALL    Delay1ms
	CALL    Delay1ms
	CALL    Delay1ms
	CALL    Delay1ms

	movlw	b'00100000'
	movwf	store		;  
	call	nibble		;   
	CALL    Delay1ms
	CALL    Delay1ms
	CALL    Delay1ms
	CALL    Delay1ms

	MOVLW	28h		; Config. 4 bits, 2 lines, 5x8 char (0010 1000b)
	CALL	cmd_aff
	CALL    Delay1ms
	CALL    Delay1ms
	CALL    Delay1ms
	CALL    Delay1ms
;	MOVLW	0Fh		; Display on, cursor on, blink cursor (0000 1111b)
	MOVLW	0Ch		; Display on, cursor oFF, NO blink cursor (0000 1100b)
	CALL	cmd_aff
	CALL    Delay1ms
	RETLW	00h

;--------------------- CLEAR LCD --------------------------------------
clr_aff
	MOVLW	01h		; Clear display & Go Home
	CALL	cmd_aff
	CALL	Delay1ms
	CALL	Delay1ms	; Wait 2 ms
	RETLW	00h

;------------------- WRITE LCD ---------------------------------------
car_aff
	BSF		cmd_car,0	; prepare a data for LCD
	goto	skeepcommand
cmd_aff
	BCF		cmd_car,0		; by default, prepare a command for LCD
skeepcommand
	movwf	store		;  
	call	nibble		;   
	
	RLF		store, F	;      
	RLF		store, F	;
	RLF		store, F	;
	RLF		store, F	;
	call	nibble		;
	RETLW	00h

nibble
	bsf		cmd_car,1	; enable=1
	call	serialize	;
	bcf		cmd_car,1	; enable=0
	call	serialize	;
	RETLW	00h

serialize
	movf	store, w
	MOVWF	ac164		; store w into the variable ac164
	MOVLF	04h,cpt1	; prepare to serialize ac164 into logic chip 74AC164
nextbit
	BTFSS	ac164,7		; ac164 bit N7 is set ?
	BCF		B_inp		; B_inp = LOW
	BTFSC	ac164,7		; ac164 bit N7 is clear ?
	BSF		B_inp		; B_inp = HIGH

	BSF		CLK		; CLK=1 => B_inp 
	NOP
	BCF		CLK		; CLK=0

	RLF		ac164,f		; next bit
	DECFSZ	cpt1,f		; rotate 4 times the variable ac164, each time test bit N7
	GOTO	nextbit		

	BSF		B_inp	; E=1, prepare Ebable = 1
	BTFSS	cmd_car,1
	BCF		B_inp	; E=0, prepare Enable = 0
	BSF		CLK		; CLK=1 => B_inp 
	NOP
	BCF		CLK		; CLK=0

	BSF		B_inp	; RS=1, prepare a data for LCD
	BTFSS	cmd_car,0
	BCF		B_inp	; RS=0, prepare a command for LCD
	BSF		CLK		; CLK=1 => B_inp 
	NOP
	BCF		CLK		; CLK=0

	BCF		B_inp	; empty Bit
	BSF		CLK		; CLK=1 => B_inp l
	NOP
	BCF		CLK		; CLK=0

	BSF		LATCH	; LATCH
	NOP
	BCF		LATCH	;
	

	MOVLF	25h,cpt1	; cpt1 = 37d
etiq1	DECFSZ	cpt1, f		; loop = 3 us * (25h=37d) = 111 us
	GOTO	etiq1

	RETLW	00h

;////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
;////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
;////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
Main                    	; Beginning of the program

			BCF		STATUS,RP0			;  0
			movlw	C_GPIO_INIT			;   ( )
			movwf	GPIO				;
;			CLRF	GPIO
;			CLRF	REGGPIO				;  
			MOVLW	b'00000111'			;
			MOVWF	CMCON				;  
			CLRF	INTCON				;  
			CLRWDT						;     
			BSF		STATUS,RP0 			;  1
			MOVLW	B'00000111'
			MOVWF	OPTION_REG			;   
			;bit 7=0					 
			;bit 5=0					    TMR0 - 
			;bit 3=0					   TMR0
			;bits 2-0=111				   1:256
			MOVLW	C_Trisio			;  TRISIO
			MOVWF	TRISIO 				; 
			MOVLW	C_Wpu				;  WPU ( )
			MOVWF	WPU 				;
			MOVLW	C_IOCB				;         
			MOVWF	IOCB				; 
			CALL	0X3FF 				;  
			MOVWF	OSCCAL 				;     
			BCF		STATUS,RP0			;  0

			;  
			movlw	C_ForSleep			;	-    
			movwf	ForSleep			;

	CLRF	cmd_car		; by default, prepare a command for LCD
	CLRF	byte_num	; first byte to receive will means a command to LCD

	CALL	Delay15ms	; Wait at least 15 ms before using LCD

;//////////////
; CAUTION, INCREASE THIS DELAY TIME IF NECESSARY
; see article: LCD modules, in the UK magazine E.P.E., Feb.1997
; (warns that we may use up to 100 ms delay time)
	CALL	Delay15ms	; Wait another 15 ms before using LCD
	CALL	Delay15ms	; Wait another 15 ms before using LCD
;//////////////

	CALL	init_aff	; Init LCD
	CALL	clr_aff		; Clear display

	LCDTXT	LCDL1, msgLin1	; SPLASH "  Temperature" from msgLin1 table

;	LCDTXT	LCDL2, msgLin2	; SPLASH "Best Regards!!!" from msgLin2 table

;	MOVLF	086h, cpt3	; cpt3 = 134d


;att3s	CALL	Delay15ms 	; 15 ms, called 134 times, give approx. 2s delay for SPLASH
;	DECFSZ	cpt3, f	
;	GOTO	att3s
			;    ''   01
			MOVLW	b'01001000'			;   CGRAM  008 -     
			CALL	cmd_aff				; send a cmd to LCD
			MOVLW	B'00000110'
			CALL	car_aff				; send a data to LCD
			MOVLW	B'00001001'
			CALL	car_aff				; send a data to LCD
			MOVLW	B'00000110'
			CALL	car_aff				; send a data to LCD
			MOVLW	B'00000000'
			CALL	car_aff				; send a data to LCD
			MOVLW	B'00000000'
			CALL	car_aff				; send a data to LCD
			MOVLW	B'00000000'
			CALL	car_aff				; send a data to LCD
			MOVLW	B'00000000'
			CALL	car_aff				; send a data to LCD
			MOVLW	B'00000000'
			CALL	car_aff				; send a data to LCD
			MOVLW	b'10000000' 		;    DDRAM     0000000 -     .	
			CALL	cmd_aff				; send a cmd to LCD
MAINCYCL:

;//////////////
;			CLRWDT
;			; 
;			BTFSC	GPIO, BUTTON		;  BUTTON
;			GOTO	BUTOFF				;  
;			; 
;			CALL	PAUSE125			; 

			;DYSPLAYTEMPER

; 
			BCF		GPIO, TEMPER		;       
			CALL	READTEMPER			;  
			;  
			XORLW	0XFF				;   
			BTFSC	STATUS, Z			
			GOTO	DISPLAYERROR		;   , 

			; ?
			btfsC	TL, 7			 	; ?
			goto	MINUS				;
			GOTO	DISPLAY

DISPLAYERROR	LCDTXT	LCDL2, msgLin3	; SPLASH "oshibka!!!" from msgLin3 table
			goto	NoData
MINUS:	; 
			comf	TL,F				;  
;		 	incf	TL,F				;  
			comf	TF,F				;  
			MOVLW	0X01
		 	ADDWF	TF,F				;  
			BTFSS	STATUS, DC
			GOTO	DISPLAY
		 	INCF	TL,F				;  

DISPLAY:
	;		BCF		STATUS, C
	;		RRF		TL, W				; 
			MOVF	TL,W				; 
			MOVWF	bin0				;   
			CALL	bcd32				;   
			MOVLW	0X0F
			ANDWF	TF, W				;    (    )
			CALL	BCD_FRACT			;   
			MOVWF	bcdF				; 


			; ?
			MOVLW	0xB0				; +	
			btfsC	TH,0			 	;  ?
			MOVLW	0xD0				;  ("-")
			IORWF	bcd1, F				;     ("+", "-")
			;   
			MOVLW	0X0F
			ANDWF	TF, W				;    
			ADDWF	TL, W				;     
			btfsS	STATUS, Z			;  ?
			; 
			GOTO	MET10
			; 
			MOVLW	0X0F
			ANDWF	bcd1, F				;  
MET10
;			CALL	clr_aff		; Clear display
;			CALL	cmd_aff		; send a cmd to LCD
				;     (1 , 2 )
				MOVLW	(.127+.4+.64)
				CALL	cmd_aff		; send a data to LCD

				;  't'
				MOVLW	0X74
				CALL	car_aff		; send a data to LCD
				;  '='
				MOVLW	0X3D
				CALL	car_aff		; send a data to LCD

				CLRF	count
	        	movlw   0x01		; -  BCD-1 ( 8. - 2-1.) 
    	        movwf   count2
			
                movlw   bcd1
                movwf   FSR
MET20
				SWAPF	INDF, W		;  
				call	PRINT_BCD_SPEC
				MOVF	INDF, W		;  
				call	PRINT_BCD_SPEC
				decf	FSR,	F
                decfsz  count2, F
                goto    MET20

				SWAPF	INDF, W		;  
				call	PRINT_BCD_SPEC
				movlw	0x01
				movwf	count		;          
				MOVF	INDF, W		;  
				call	PRINT_BCD_SPEC
				;  
				MOVLW	0X2E
				CALL	car_aff		; send a data to LCD
				;   
				MOVF	bcdF, W		; 
				ADDLW	0X30		;     ASCII
				CALL	car_aff		; send a data to LCD
				;  ''
				MOVLW	0X01
				CALL	car_aff		; send a data to LCD
				;  'C'
				MOVLW	0X43
				CALL	car_aff		; send a data to LCD
				;  ' '
				MOVLW	0X20
				CALL	car_aff		; send a data to LCD
				;  ' '
				MOVLW	0X20
				CALL	car_aff		; send a data to LCD
				;  ' '
				MOVLW	0X20
				CALL	car_aff		; send a data to LCD

NoData:
				call	PAUSE125	;    
				call	PAUSE125	; 
				call	PAUSE125	; 
				call	PAUSE125	; 

;				movlw	C_ForSleep	;     ,   
;				btfss	GPIO, BUTTON;
;				movwf	ForSleep	;

				decfsz	ForSleep, F	;          ( )
				GOTO	MAINCYCL	;
;-----------
;				CALL	clr_aff		; Clear display

				BANKSEL	TRISIO
				BSF		GPIO, POWER ;  
				BANKSEL	GPIO

				call	PAUSE125	;    
				call	PAUSE125	; 
				call	PAUSE125	; 
				call	PAUSE125	; 
;				GOTO	$-1
				

;				BSF		INTCON, GPIE;        GPIO
;				MOVF	GPIO, W		;   GPIO   
;				BCF		INTCON, GPIF;  
;spim:
;				sleep
;				NOP
;				btfss	STATUS, NOT_TO ;   
;				goto	spim
;				BCF		INTCON, GPIE;        GPIO 
 
				GOTO	MAINCYCL	;  ,        
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

;-----------------
;   -   LCD       
PRINT_BCD_SPEC
				ANDLW	0X0F		; 
				addlw	0x06		;   BCD
				btfsc	STATUS, DC	;     (    ?)
				;  ( )
				goto	PRINTSPEC
				; 
				addlw	0xfa		;   ,    
				btfss	STATUS, Z	; 
				;  
				goto	MET30
				; 
				movf	count, F	;    (    ?)
				btfsc	STATUS, Z	; 
				;  ( ,   )
				goto	MET40		;  
				;   (, )
MET30
				ADDLW	0X30		;     ANSI
				CALL	car_aff		; send a data to LCD
				movlw	0x01
				movwf	count		;            
				goto	MET40
PRINTSPEC
				addlw	0xfa		;   
				ADDLW	0X20		;     ANSI
				CALL	car_aff		; send a data to LCD
MET40				
				RETURN
;-----------------

;//////////////
;    - 
		;     bin0    
                ;movlw   .198	
 ;               movwf   bin0
 ;               call    bcd32
;mm2             
 ;               movlw   0x77


bcd32
                clrf    count

                clrf    bcd0
                clrf    bcd1
mark1
                movlw   0x03		;  -  (32.- 9 (3+5), 8. - 3 (1+2)) 
                movwf   count2
                movlw   bin0
                movwf   FSR
                bcf     STATUS, C
mark2
                rlf     INDF, F
                incf    FSR, F
                decfsz  count2, F
                goto    mark2

                incf    count, F
                btfsc   count, 3	;   /2     ( 32-  - 5, 16 .-4, 8 . -3)

                return

mark3
                movlw   0x02		; -     (32.- 5 , 8. - 2)
                movwf   count2
                
mark4
                decf    FSR, F
                movlw   0x03
                addwf   INDF, F
                btfss   INDF, 3 
                subwf   INDF, F
                movlw   0x30
                addwf   INDF, F
                btfss   INDF, 7 
                subwf   INDF, F
                decfsz  count2, F
                goto    mark4
                goto    mark1
;//////////////		



;--------------------------------------------------------------------------

;	      


;;;;;;;;;;;;;;;;;;;;;;;;;;;  


			



			


;-----------


PAUSE025:	
	      	movlw       .169
            movwf       Reg_1
            movlw       .69
            movwf       Reg_2
            movlw       .2
            movwf       Reg_3
wr:          
			decfsz      Reg_1, F
			goto        wr
			clrwdt
            decfsz      Reg_2, F
            goto        wr
            decfsz      Reg_3, F
            goto        wr
			return

;delay = 125'000 machine cycles
PAUSE125   	movlw       .85
            movwf       Reg_1
            movlw       .163
            movwf       Reg_2
wr2         decfsz      Reg_1, F
            goto        wr2
			clrwdt
            decfsz      Reg_2, F
            goto        wr2
			RETURN

;--------------------------------------------------------------------------------------------------
                ;  (  TEMP1)

Pause       clrwdt
		 	movwf     TEMP1            ;     W (  )
		 	movf      TEMP1,F          ;  0
			btfsc     STATUS,Z         ;    0,  Z=0   return
		 	return                     ;    0,   
		 	clrw                       ; W
P_label  	addlw     01h              ;   W
		 	jnz       P_label
		 	clrwdt  
         	decfsz    TEMP1,F          ;   TEMP1
         	goto      P_label          ;
		 	clrwdt  
		 	return                     ;  

;--------------------------------------------------------------------------------------------------
		;   DS18B20 (  TEMP1)

CHECK_TERMOMETR:
TestDS:
			CLRWDT
		
			movlw   038h				
			btfss   GPIO,TEMPER      	;   ?
			goto    Test4_label			;,  - , 
			BSF		STATUS, RP0			;  1
			bcf     GPIO,TEMPER        	; 1-Wire
			BCF		STATUS, RP0			;  0
							           	;  (  480 )
			movlw	050h
Test1_label:
			addlw	01h
            btfss	STATUS,Z          	;(    xxx  
            goto	Test1_label       	;   TMR0)
			CLRWDT
			BSF		STATUS, RP0			;  1
			bSf		GPIO,TEMPER
			BCF		STATUS, RP0			;  0
							            ; 1-Wire 

				 movlw     D'239'
Test2_label      addlw     01h                   ;   DS18B20 ( ~70 )
                 btfss     STATUS,Z
                 goto      Test2_label
			CLRWDT
				 clrf      TEMP1
				 movlw     D'252'
Test3_label      btfss     GPIO,TEMPER               ;  (0) ?
				 incf      TEMP1,F				 ; -  TEMP1
				 addlw     01h                   ;
                 btfss     STATUS,Z
                 goto      Test3_label
			CLRWDT
				 goto      Testend_label         ;
		
Test4_label      addlw     01h                   ;    800 
                 jnz       Test4_label
				 movlw     0
			CLRWDT

Testend_label	 movlw     075h
				 addlw     01h                   ;   DS18B20 555 
                 jnz       Testend_label+1
			CLRWDT
				 movlw     04h					 ;  DS18B20 ,  TEMP1 = 4
				 xorwf     TEMP1,W
				 btfsc     STATUS,Z              ;TEMP1 = 4 ? 
				 movlw     0FFh                  ;  -    (W=0FFh)

Stop_label:
 				return                          ;  
;--------------------------------------------------------------------------------------------------
		; /   1-Wire (   W=0FFh).  TEMP1
RW_1Wire	 
				 movwf     TEMP1				 ;   W
				 movlw     08h                   ;8 
				 movwf     COUNTER
RWLoop			 bcf       INTCON,GIE            ;  
				BSF		STATUS, RP0				;  1
			 	bcf		GPIO,TEMPER             ;0 --> 1-Wire
				BCF		STATUS, RP0				;  0

				BSF		STATUS, RP0				;  1
				btfsc     TEMP1,0
				bsf     GPIO,TEMPER             ;,   TEMP1 = 1
				BCF		STATUS, RP0				;  0

				 rrf       TEMP1,F               ;  
				 movlw     0FDh					 ; ~12 
RW_1label        addlw     01h
				 jnz       RW_1label
			CLRWDT
				 bcf       TEMP1,7               ;    TEMP1
				 btfsc     GPIO,TEMPER
				 bsf       TEMP1,7
								
				 movlw     D'220'                ;    
RW_2label        addlw     01h
				 jnz       RW_2label
			CLRWDT
				BSF		STATUS, RP0				;  1
				bsf     GPIO,TEMPER             ; 
				BCF		STATUS, RP0				;  0
 				;MOVF	REGGPIO,W
				;MOVWF	GPIO

				;mov       PORTA,OUTA
				;
				 bsf       INTCON,GIE            ; 

				 decfsz    COUNTER,F			 ;8  ?
				 goto      RWLoop                ;  - 

				 movf      TEMP1,W               ;   W

				 return							 ;  /   1-Wire
;--------------------------------------------------------------------------------------------------
		;  CRC.   W.   TEMP1, TEMP2

NewCRC			 clrwdt
				 movwf     TEMP2                 ; W
				 movlw     08h
				 movwf     COUNTER               ;8 --> COUNTER
				 movf      TEMP2,W               ;  W
CRC_label		 xorwf     CRCPIC,W              ;. CRCPIC  W,   W
				 movwf     TEMP1                 ;   TEMP1
				 rrf       TEMP1,W               ; TEMP1   1,   W,    
				 movf      CRCPIC,W              ;CRCPIC --> W (   )
				 btfsc     STATUS,0
				 xorlw     018h                  ; =0,     
				 movwf     TEMP1                 ;  TEMP1
				 rrf       TEMP1,W               ; ,   W
				 movwf     CRCPIC                ;   CRCPIC
				 bcf       STATUS,0              ;0 --> C
				 rrf       TEMP2,F               ; TEMP2   1
				 movf      TEMP2,W               ;     W
				 clrwdt
				 decfsz    COUNTER,F
				 goto      CRC_label
 				 return							 ;   CRC
;__________________________________________________________________________________________________
;

READTEMPER:
			clrwdt		                 ;   DS18B20


		 call      TestDS		 ;   
		 xorlw     0FFh
		 jnz       ERROREXIT		 ; -    

		 movlw     0CCh			 ; "Skip ROM"
		 call      RW_1Wire
		 movlw     044h			 ; "Convert T"
		 call      RW_1Wire

		 movlw     0FFh 		 ;  
		 call      Pause
		 movlw     0FFh
		 call      Pause
		 movlw     0FFh
		 call      Pause

		 mvi       TRY,08h               ;8  

Newtry_label	 clrwdt                 	 ;    DS18B20
		 call      TestDS		 ;   
		 xorlw     0FFh
		 jnz       ERROREXIT		 ; -    

		 movlw     0CCh			 ; "Skip ROM"
		 call      RW_1Wire
		 movlw     0BEh			 ; "Read Scratchpad"
		 call      RW_1Wire

		 clrf      CRCPIC
		 movlw     0FFh
		 call      RW_1Wire
		 movwf     TL                    ;  
		 call      NewCRC
		 movlw     0FFh
		 call      RW_1Wire
		 movwf     TH                    ;  
		 call      NewCRC
		 movlw     0FFh                  ;  
		 call      RW_1Wire
		 call      NewCRC
		 movlw     0FFh
		 call      RW_1Wire
		 call      NewCRC
		 movlw     0FFh
		 call      RW_1Wire
		 call      NewCRC
		 movlw     0FFh
		 call      RW_1Wire
		 call      NewCRC
		 movlw     0FFh
		 call      RW_1Wire
		 call      NewCRC
		 movlw     0FFh
		 call      RW_1Wire
		 call      NewCRC

		 movlw     0FFh
		 call      RW_1Wire
		 xorwf     CRCPIC,W              ;  CRC
		 jz        OKCRC_label           ; - 

		 decfsz    TRY,F
		 goto	   Newtry_label          ; -  
		 goto      ERROREXIT             ; 

OKCRC_label	 clrwdt
		 rrf	   TH,F
		 rrf	   TL,F
		 rrf	   TF,F

		 rrf	   TH,F
		 rrf	   TL,F
		 rrf	   TF,F

		 rrf	   TH,F
		 rrf	   TL,F
		 rrf	   TF,F

		 rrf	   TH,F
		 rrf	   TL,F			; | 64 | 32 | 16 || 8 | 4 | 2 | 1 |
		 rrf	   TF,F			; 0.5 | 0.25 | 0.125 | 0.0625 || ? | ? | ? | ?
		 swapf	   TF,F			; ? | ? | ? | ? || 0.5 | 0.25 | 0.125 | 0.0625 
		
		CLRW
		RETURN

ERROREXIT:
		MOVLW		0XFF
		RETURN




	END
